﻿Imports ThinkGeo.MapSuite.SilverlightCore
Imports ThinkGeo.MapSuite.SilverlightEdition
Imports System.Windows.Resources

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Map1_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Map1.MapUnit = GeographyUnit.DecimalDegree
        Map1.Background = New SolidColorBrush(Color.FromArgb(255, 156, 187, 216))

        Dim serverOverlay As New ServerLayerOverlay("NativeServer", "SilverlightMapConnector1")
        Map1.Overlays.Add(serverOverlay)

        Dim statesLayer As New ShapeFileFeatureLayer("STATES.SHP")
        AddHandler DirectCast(statesLayer.FeatureSource, ShapeFileFeatureSource).StreamLoading, AddressOf StatesLoadAShapeFile_StreamLoading
        statesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1)
        statesLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.Canal1("STATE_NAME")
        statesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05

        statesLayer.ZoomLevelSet.ZoomLevel06.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromHtml("#EFEFEF"), GeoColor.FromHtml("#CCCCCC"), 1)
        statesLayer.ZoomLevelSet.ZoomLevel06.DefaultTextStyle = TextStyles.Capital3("STATE_NAME")
        statesLayer.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        Dim layerOverlay As New LayerOverlay()
        layerOverlay.Layers.Add(statesLayer)
        Map1.Overlays.Add(layerOverlay)

        Map1.ZoomTo(New PointShape(-100, 35), 4)
    End Sub

    ' Load Shape files from resource.
    Private Sub StatesLoadAShapeFile_StreamLoading(ByVal sender As Object, ByVal e As StreamLoadingEventArgs)
        Select Case System.IO.Path.GetExtension(e.AlternateStreamName).ToLower()
            Case ".shp"
                Dim sr As StreamResourceInfo = Application.GetResourceStream(New Uri("App_Data/STATES.SHP", UriKind.RelativeOrAbsolute))
                e.AlternateStream = sr.Stream
                Exit Select
            Case ".dbf"
                e.AlternateStream = Application.GetResourceStream(New Uri("App_Data/STATES.DBF", UriKind.RelativeOrAbsolute)).Stream
                Exit Select
            Case ".shx"
                e.AlternateStream = Application.GetResourceStream(New Uri("App_Data/STATES.SHX", UriKind.RelativeOrAbsolute)).Stream
                Exit Select
            Case ".idx"
                e.AlternateStream = Application.GetResourceStream(New Uri("App_Data/STATES.idx", UriKind.RelativeOrAbsolute)).Stream
                Exit Select
            Case ".ids"
                e.AlternateStream = Application.GetResourceStream(New Uri("App_Data/STATES.ids", UriKind.RelativeOrAbsolute)).Stream
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub
End Class